<script lang="ts">
    import ColorPicker from "../components/ColorPicker.svelte";
    import Container from "../components/Container.svelte";
    import Icon from "../components/Icon.svelte";
    import Input from "../components/Input.svelte";
    import NeonSign from "../components/NeonSign.svelte";
    import Radio from "../components/Radio.svelte";
    import Switch from "../components/Switch.svelte";
    import { themeSettings } from "../store/settings";

	let userImages: string[] = [];
	let themeImages: string[] = [];

	window.theme_utils.dirlist(window.greeter_config.branding.background_images_dir, true, (files) => {
		userImages = files;
	});

    window.theme_utils.dirlist("/usr/share/web-greeter/themes/neon/assets/img/backgrounds", true, (files) => {
		themeImages = files;
	});

	const onClick = (img: string) => {
		$themeSettings.background_image = img;
	}    
    const fontOptions: RadioOption[] = [
        {value: "Luciole",text: "Luciole",icon: "Pencil24"}
    ]

    const colorCallback = (e: CustomEvent) => {
        $themeSettings.colors.accent_color = e.detail;
    }

</script>

<Container>
    <div id="settings">
        <div class="flex flex-col gap-8">
            <div class="flex flex-col border rounded p-4">
                <div class="flex flex-wrap lg:flex-nowrap">
                    <div class="flex w-full lg:w-1/2">
                        <Switch bind:checked={$themeSettings.skip_splashscreen} title="Désactiver le splash" subtitle="Passer le splash" name="skip-splashscreen" icon="EyeClosed24" />
                    </div>
                    <div class="flex w-full lg:w-1/2">
                        <Switch bind:checked={$themeSettings.sign.flicker} title="Animation Flicker" subtitle="Animation supplémentaire (utilise plus de ressources matérielles)" name="flicker" icon="LightBulb24" />
                    </div>
                </div>
                <div class="flex flex-wrap lg:flex-nowrap">
                    <div class="flex w-full lg:w-1/2">
                        <Switch bind:checked={$themeSettings.sign.show_clock} title="Horloge" subtitle="Montre une horloge au splash" name="show-clock" icon="Clock24" />
                    </div>
                    <div class="flex w-full lg:w-1/2">
                        <Switch bind:checked={$themeSettings.background_blur} title="Arrière-plan flouté" subtitle="Arrière-plan flouté (utilise plus de ressources matérielles)" name="blur-background" icon="Image24" />
                    </div>
                </div>
            </div>
            
    <div id="backgrounds">
            <div class="flex flex-col gap-2 text-sm">
            <span class="flex gap-2 items-center">
                <Icon icon="Image16" />
               Choix de l'arrière plan
            </span>
            <div id="custom-images" class="image-group">
                {#each themeImages as img}
                    <div class="image" style="--bg-image: url('{img}')" on:click={() => onClick(img)}></div>
                {/each}
            </div>
        </div>
    </div>
    
            <div class="flex flex-col gap-2 text-sm w-full">
                <span class="flex gap-2 items-center">
                    <Icon icon="Eye16" />
                    Aperçu
                </span>
                <div class="preview">
                    <NeonSign 
                    font={$themeSettings.sign.font} 
                    text={$themeSettings.sign.text} 
                    flicker={$themeSettings.sign.flicker} 
                    color={$themeSettings.colors.accent_color} 
                    showClock={$themeSettings.sign.show_clock}
                    size="4rem" />
                </div>
            </div>    
    
            <div class="flex flex-col gap-2 text-sm">
                <span class="flex gap-2 items-center">
                    <Icon icon="Pencil16" />
                    Texte du splash
                </span>
                <Input bind:value={$themeSettings.sign.text} />
            </div>
                
            <div class="flex gap-4 w-full flex-wrap lg:flex-nowrap">
                <div class="flex flex-col gap-2 text-sm">
                    <span class="flex gap-2 items-center">
                        <Icon icon="Paintbrush16" />
                        Choix des couleurs
                    </span>
                    <ColorPicker startColor={$themeSettings.colors.accent_color} on:colorChange={colorCallback} width={300} height={220}  />
                </div>
    
                <div class="flex flex-col gap-2 text-sm">
                    <span class="flex gap-2 items-center">
                        <Icon icon="Typography16" />
                        Polices
                    </span>
                    <Radio id="font" bind:value={$themeSettings.sign.font} options={fontOptions} />    
                </div>
            </div>
        </div>
    </div>
</Container>

<style>
    #settings {
        @apply text-white fill-white overflow-auto w-full max-h-full;
        will-change: scroll-position; /* this helps with performance */
    }

    .preview {
        @apply flex items-center justify-center w-full py-8 border rounded;
    }
    #backgrounds {
        @apply flex flex-col gap-8 text-white fill-white;
    }

	.image-group {
		@apply flex flex-wrap gap-4;
	}

	.image {
		@apply w-256px h-144px hover:bg-gray-400 bg-cover bg-center border border-gray-400 bg-blend-overlay transition cursor-pointer;
    background-image: var(--bg-image);
	}
</style>
